////////////////////////////////////////////////////////////////
//
// Task Binary Tree
// File: branch.cpp
// Name: <your name>
// Student number:
//
// Contents: Bodies of member functions of class 'branch'
//
// You'll need to implement member functions in this file.
// Mail this file to computation@ics.ele.tue.nl
// Skeleton function by patrick@magma-da.com
////////////////////////////////////////////////////////////////
 #include "tree.h"
 #include <string.h>
 #include <stdlib.h>
 #include <iostream.h>


  ////////////////////////////////////////////////////////////////
 //
 // Constructor of a branch tree element
 // This will allocate memory to save the word.
 // It sets the _word pointer, and copies the wored into it.
 // It also initializes the _left and _right
 // pointers to 0 (meaning the branch is a leaf).
 //
 branch::branch(const char * const word)
 {
    _left = _right = 0;
    if(word) {
       // if there is a word ptr, save a copy of it
       _word = (char *) malloc((strlen(word)+1) * sizeof(char));
       strcpy(_word, word);
    } else {
      _word = 0;
      cerr << "WARNING: Constructing a branch without a name." << endl;
    }
 }

  ////////////////////////////////////////////////////////////////
 //
 // The destructor of a branch tree element.
 // Frees the memory that was allocated to store the word.
 // It does NOT delete the _left and _right child branches.
 // Therefore this destructor is non-recursive.
 //
branch::~branch()
 {
    if(_word)
       free(_word);  // free the string

    _word = 0; // not really necessary, but it could help debugging
 }


  ////////////////////////////////////////////////////////////////
 //
 // Destroys and deletes this branch of the tree and everything below it.
 // This means that it recursively destroys the subtrees that _left
 // and _right point to.
 // Finally, it self-destructs this branch object by
 // calling delete(this);
 // (approx. 5 lines)
 //
void branch::destroy(void)
{
//////
////// TO BE IMPLEMENTED BY YOU!
//////
    cerr << "ERROR: branch::destroy() is not yet implemented." << endl;
}


 ////////////////////////////////////////////////////////////////
//
// Adds a word to this tree element recursively.
//
// The tree is maintained such that the words are
// sorted alphabetically in case the tree is traversed in order.
// You can use the function strcmp(str1, str2). This function returns a
// number < 0 in case str1 is alphabetically before str2, and
// a number > 0 in case str2 is after str1 in the dictionary.
// In case strcmp(str1, str2) returns 0, the strings are equal.
// The main idea is to build the tree such that for each branch
// the _left child-tree contains words that are alphabetically to the
// left of the word, and the _right subtree the words that are
// alphabetically after the word of the branch.
//
// Your target: About 12 lines of code (and use recursion!)
//
void branch::add(const char * const word)
{
   /*
    Implement something along these lines:
    compare word with _word using strcmp()
    if word is before _word then add word to left childtree
    if word is after _word then add word to right childtree
    if word is equal to _word then do nothing because the word
      already exists.

    In case a subtree already exists, recursively call this
    member function on the _left or _right subtree.
    In case there is no such subtree, make a new leaf-branch.
   */
/////
///// TO BE IMPLEMENTED BY YOU!
/////
    cerr << "ERROR: branch::add() is not yet implemented." << endl;
}


 ////////////////////////////////////////////////////////////////
//
// Returns the length of the longest path from any
// branch to the root.
// This is a recursive routine as well.
//
// Your target: 8 lines of code.
//
int branch::height(void) const
{
/*
   Something like: get height of each of the two child
   trees, and then return the longest of these two + 1
 */
/////
///// TO BE IMPLEMENTED BY YOU
/////
    cerr << "ERROR: branch::height() is not yet implemented." << endl;
    return -1;
}


 ////////////////////////////////////////////////////////////////
//
// Count the number of words (branches) of the subtree.
//
// Your target: Approx. 6 lines of recursive code
//
int branch::count(void) const
{
/////
///// TO BE IMPLEMENTED BY YOU
/////
    cerr << "ERROR: branch::count() is not yet implemented." << endl;
    return -1;
}


 ////////////////////////////////////////////////////////////////
//
// Returns a pointer to the branch that contains the
// string "word".
// Will return 0 in case the word is not in this
// (sub-)tree.
//
// Target: some some 15 lines (recursive)
//
branch * branch::find(const char * const word) const
{
/////
///// TO BE IMPLEMENTED BY YOU
/////
    cerr << "ERROR: branch::find() is not yet implemented." << endl;
    return 0;
}


 ////////////////////////////////////////////////////////////////
//
// Prints all words of the subtree of this branch in
// alphabetical order.
// Since we maintain the tree such that it is always
// alphabetically sorted, we only need to traverse the
// tree in-order (recursively) and print the elements.
//
// Target: Approx. 5 lines.
//
void branch::print_words_alphabetically(void) const
{
/////
///// TO BE IMPLEMENTED BY YOU
/////
    cerr <<  "ERROR: branch::print_words_alphabetically() is not yet implemented." << endl;
}



 /////////////////////////////////////////////////////////////////
//
// Implementing the functions below is optional.
// Doing so will earn you kudos.
//
/////////////////////////////////////////////////////////////////

/* * * * * * * * *
 *
 * Removes a word from the tree, and returns a
 * pointer to the branch that contains the deleted word. It does
 * not delete the branch itself.
 * The idea is first to find the branch that contains the word,
 * and then to take that branch out of the tree.
 * This is quite tough.
 *
 * * * * * * * * */
branch * branch::remove(const char * const word, branch ** ptr_ptr)
{
/////
///// TO BE IMPLEMENTED BY YOU
/////
    printf("ERROR: branch::remove() is not yet implemented.\n");
    return 0;
}


/* * * * * * * * *
 *
 * Help routine for remove_word_from_tree
 * this recursive function finds the 'alphabetically largest'
 * word in (sub-)tree. This means: it returns a pointer
 * to the word that has the largest value out of strcmp().
 *
 * * * * * * * * */
const char * // help routine for the above function
branch::get_largest_word(void) const
{
   if(_right)
      return _right->get_largest_word();
   else
      return _word;
}


