////////////////////////////////////////////////////////////////
//
// Task Binary Tree
// File: io.cpp
// Name: <your name>
// Student number:
//
// Contents: The file IO member functions of the
//           classes tree and branch
//
// You'll need to complete functions in this file.
// Mail this file to computation@ics.ele.tue.nl
// Skeleton functions by patrick@magma-da.com
////////////////////////////////////////////////////////////////
#include "tree.h"

 ////////////////////////////////////////////////////////////////
//
// Writes the entire contents of the tree into a file
// called fname. The words are saved one per line.
// This functions calls branch::write_pre_order(..)
// on the root branch to output the strings into
// the file.
//
void tree::write_into_file(const char * const fname) const
{
   FILE * fp;
   if(_root == 0)
      return;  // nothing to write...
   if((fp = fopen(fname,"w")) == 0) {
      printf("Cannot open file\n");
      return;
   }
   _root->write_pre_order(fp);   // calls wrote function on the root branch.
   fclose(fp);
}


 ////////////////////////////////////////////////////////////////
//
// Recursively prints the strings of the tree
// into file 'fp'. Print them out 'in order', meaning
// that we first print the contents of the branch (followed
// by a '\n'), and then recurse into each of the two
// children _left and _right.
// This function is called from tree::write_into_file(..)
//
// Target: approx. 5 lines
//
void branch::write_pre_order(FILE * const fp) const
{
/////
///// TO BE IMPLEMENTED BY YOU
/////
    printf("ERROR: branch::write_pre_order() is not yet implemented.\n");
}


 ////////////////////////////////////////////////////////////////
//
// Reads all strings from the file 'fname' into
// the tree. This function first opens the file,
// and then reads all words from the file (e.g.
// using fscanf(fp,"%s",word)  )
// Each word is added to the tree using
// this->add(word);
// finally, the file stream is closed.
//
// Target: approx. 12 lines
//
void tree::read_from_file(const char * const fname)
{
/////
///// TO BE IMPLEMENTED BY YOU
/////
    printf("ERROR: tree::read_from_file() is not yet implemented.\n");
}
