///////////////////////////////////////////////////
//
// Task Binary Tree
// File: tree.cpp
// Name: <your name>
// Student number:
//
// Contents: Bodies of member functions of class 'tree'
//
// This file is fully implemented. If you did not
// edit it, you do not need to mail it in.
// Skeleton function by patrick@magma-da.com
///////////////////////////////////////////////////
 #include "tree.h"
 #include <string.h>
 #include <stdlib.h>

///////////////////////////////////////////////////
//
// Constructor of the tree class
// Initializes the tree as an empty tree.
//
tree::tree(void)
{
   _root = 0;
}

///////////////////////////////////////////////////
//
// Destructor of the tree class.
// Destroys the entire contents of the tree.
//
tree::~tree(void)
{
   if(_root)          // destroy tree if its present
      _root->destroy();
}


 ///////////////////////////////////////////////////
//
// Adds word to the tree. This member funtion is
// merely a 'wrapper' around the recursive function
// branch::add(word) that does the actual work.
//
void tree::add(const char * const word)
{
   if(word == 0)
      return;    // do nothing if there is no word
   if(_root == 0) {
      // this is the first branch of the tree: make _root point to it
      _root = new branch(word);
   } else {
      // a root already exists: toss the word into the 'add' member function
      _root->add(word);
   }
}


 ///////////////////////////////////////////////////
//
// Deletes all branches of the tree. Again, this is a
// wrapper for the recursive function branch::destroy()
// that wipes out the tree.
//
void tree::destroy(void)
{
   if(_root != 0)
      _root->destroy();  // this will recurse the tree of branches
   _root = 0;
}

 ///////////////////////////////////////////////////
//
// Removes a word from the tree. Again its a wrapper
// for a member function of class branch.
// Implementing this function is optional.
//
void tree::remove(const char * const word)
{
   if(_root == 0 || word == 0)
      return; // there is no tree or no word: just return.

   // removes the branch containing 'word'
   // To enable changing the parent pointer, we give the
   // address of the pointer that is pointing to the object
   // as a argument to the function.
   branch * dead_branch = _root->remove(word, &_root);
   if(dead_branch)
      delete dead_branch;  // delete the branch if it was extracted.
}
